package com.yerihyo.yeritools.io;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class CompoundOutputStream extends OutputStream {
	private List<OutputStream> oStreamList = new ArrayList<OutputStream>();
	
	public void addOutputStream(OutputStream oStream){
		oStreamList.add(oStream);
	}
	public void removeOutputStream(OutputStream oStream){
		oStreamList.remove(oStream);
	}
	
	public CompoundOutputStream(){ }
	public CompoundOutputStream(Collection<? extends OutputStream> c){ oStreamList.addAll(c); }
	
	public void close() throws IOException{
		for(OutputStream oStream : oStreamList){ oStream.close(); }
	}
	
	public void flush() throws IOException{
		for(OutputStream oStream : oStreamList){ oStream.flush(); }
	}

	public void write(byte[] b) throws IOException {
		for(OutputStream oStream : oStreamList){ oStream.write(b); }
	}
	
	public void write(byte[] b, int off, int len) throws IOException {
		for(OutputStream oStream : oStreamList){ oStream.write(b, off, len); }
	}
	
	public void write(int arg0) throws IOException {
		for(OutputStream oStream : oStreamList){ oStream.write(arg0); }
	}

}
