package com.yerihyo.yeritools.io;

import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;

public class CompoundWriter extends Writer {
	private List<Writer> writers;
	
	public CompoundWriter(){ writers = new ArrayList<Writer>(); }
	public CompoundWriter(List<Writer> in_writers){ writers = in_writers; }

	public void addWriter(Writer writer){ writers.add(writer); }
	public void getWriter(int index){ writers.get(index); }
	public void removeWriter(Writer writer){ writers.remove(writer); }
	
	@Override
	public void close() throws IOException {
		for(Writer writer : writers){ writer.close(); }
	}

	@Override
	public void flush() throws IOException {
		for(Writer writer : writers){ writer.flush(); }
	}

	@Override
	public void write(char[] arg0, int arg1, int arg2) throws IOException {
		for(Writer writer : writers){ writer.write(arg0, arg1, arg2); }
	}

}
